<?php

// These variables match what is being sent by the Nagios notification Command
// "$CONTACTPAGER$" $NOTIFICATIONTYPE, $HOSTNAME$, $SERVICEDESC, $SERVICESTATE, $SERVICEOUTPUT, $SHORTDATETIME$"

 $CONTACTPAGER = $argv[1];
 $HOSTNAME = $argv[2];
 $NOTIFICATIONTYPE = $argv[3];
 $SERVICEDESC = $argv[4];
 $SERVICESTATE = $argv[5];
 $SERVICEOUTPUT = $argv[6];
 $TIME = $argv[7];

 $address = "address to Multitech Cellular Gateway";
 $username = "username";
 $password = "password";
 $filename = "/usr/local/nagiosxi/tmp/token.txt";
 $timespan = "300"; 	//5 minutes
 $current_time = time();


// Get Auth Token
// Sessions expire 5 minutes after the last request to the server.

if (file_exists($filename)) { $file_time = date(filemtime($filename)); }

$diff = $current_time - $file_time;

if (($current_time - $file_time) < $timespan) {
		// If token time is less than timespan use it and touch the file
                $token = file_get_contents("$filename");
		(touch($filename));
                } else {

// Get New Token
        $auth_url = 'https://'.$address.'/api/login';
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $auth_url);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, '{"username":"'.$username.'","password":"'.$password.'"}');
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Expect:'));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));
        $authorization = curl_exec($curl);
        curl_close($curl);
        $authorization = json_decode($authorization, true);
        $token = $authorization['result']['token'];

// Write Token to file
        $keyfile = fopen("$filename", "w") or die("Unable to open file $filename!");
        fwrite($keyfile, $token);
        }

//$message = "$HOSTNAME ($SERVICEDESC) $NOTIFICATIONTYPE $SERVICESTATE $SERVICEOUTPUT $TIME";
$message = "$HOSTNAME ($SERVICEDESC) $NOTIFICATIONTYPE $SERVICEOUTPUT $TIME";

// Send the SMS request

    $send_url = 'https://multitechsms.gtc.edu/api/sms/outbox';
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $send_url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, '{"recipients":["'.$CONTACTPAGER.'"],"message":"'.$message.'"}');
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_COOKIE, "Cookie: token=$token");
    curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    $sent_response = curl_exec($curl);
    curl_close($curl);

    $sent_response = json_decode($sent_response, true);
    $response_code = $sent_response['code'];

 if ($response_code != "200")  {
	// If unable to send delete keyfile
        if (file_exists($filename)) { unlink($filename); }
        return 1;
    	}
    return 0;

